---
# tasks file for ipconfig
- name: Gather facts from new server
  setup:
    filter: ansible_default_ipv4.address

- name: Gather service facts from server
  service_facts:



# Context
# -------
# The context section is used to load variables. This has been built in a specific order so that subsequent variable files override earlier variables.
# This generates a specicifity very similar to what we see in Chef.
# The order is as follows:
#  - OS Family (i.e: Debian, RedHat)
#  - Distribution (i.e: RedHat Enterprise, CentOS, Ubuntu)
#  - LSB name (i.e: Raspbian) - only applicable to Debian-based OS's, and primarily needed to support Raspbian on Raspberry Pi's as its the only place Raspbian is specified
#  - Distribution-Version (i.e: Debian-10)
#  - Hostname (as specificed in inventory file)
#  - Hostname (as read by Ansible)
#  - IP Address

# Remember these are CASE SENSITIVE


# This deals with family-specific variabiles. Store them in /var/family/___.yml
- name: Load OS family specific variables file
  include_vars:
    file: "context/family/{{ansible_os_family}}.yml" # RedHat.yml
  ignore_errors: true


# This deals with os-specific variabiles. Store them in /var/os/___.yml
- name: Load os specific variables file
  include_vars: "{{ item }}"
  with_first_found:
    - "context/os/{{ ansible_distribution }}-{{ ansible_distribution_major_version }}.yml" # Debian-10.yml
    - "context/os/{{ ansible_lsb.id }}.yml" # Raspbian.yml
    - "context/os/{{ ansible_distribution }}.yml" # RedHat.yml
  ignore_errors: true


# We load these in blocks to that we dont have to copy every single varialbe into files with a higher specicity.
# Remember:
#   - Variables in more specific files completely overwrite variables loaded before it.
#   - Variables do not concatonate. You must specify the whole variable again.
# -------

- name: Install Packages
  package:
    name: "{{item}}"
    state: present
  with_items: "{{package_install}}"
  ignore_errors: True

- include: ipconfig.yml
  when: ansible_os_family == "RedHat"

- include: raspbian.yml
  when: ansible_distribution == "Debian" and ansible_lsb.id == "Raspbian"